let connectedDevices = new Map();
let deviceSensorData = new Map();

export { connectedDevices, deviceSensorData };

function cleanupDevices() {
  const fiveMinutesAgo = new Date(Date.now() - 5 * 60 * 1000);
  let updated = false;

  for (const [deviceId, device] of connectedDevices.entries()) {
    if (device.lastSeen < fiveMinutesAgo && device.status === "online") {
      connectedDevices.set(deviceId, { ...device, status: "offline" });
      updated = true;
    }
  }

  return updated;
}

export function getCurrentDevices() {
  cleanupDevices();
  return Array.from(connectedDevices.values()).map((device) => {
    const sensorData = deviceSensorData.get(device.id);
    return {
      ...device,
      sensorData: sensorData || null,
    };
  });
}

export function getDeviceSensorData(deviceId) {
  return deviceSensorData.get(deviceId) || null;
}
