import { db } from "$lib/server/db";
import * as table from "$lib/server/db/schema"
import { eq } from "drizzle-orm";

export const GET = async (event) => {
  console.log(event.locals.session.userId)
  const rawData = await db.select({ 
    altitude: table.sensorData.altitude, 
    humidity: table.sensorData.humidity, 
    pressure: table.sensorData.pressure, 
    temperature: table.sensorData.temperature, 
    date: table.sensorData.time,
    sensorId: table.sensorData.sensor,
    user: table.sensors.user,
  }).from(table.sensorData).innerJoin(table.sensors, eq(table.sensors.id, table.sensorData.sensor)).where(eq(table.sensors.user, event.locals.session.userId));
  
  const data = rawData.map(item => ({
    ...item,
    pressure: Math.round((item.pressure / 1000) * 10) / 10
  }));
  
  console.log(`Returning ${data.length} data points`);

  return new Response(JSON.stringify(data), {
    headers: {
      "Content-Type": "application/json"
    }
  });
}
